org.apache.fop.area

## Class Trait.InternalLink

- java.lang.Object
- - org.apache.fop.area.Trait.InternalLink

All Implemented Interfaces:
  Serializable

Enclosing class:
  Trait

    public static class Trait.InternalLink
    extends Object
    implements Serializable

Class for internal link traits. Stores PageViewport key and producer ID

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`InternalLink(String attrValue)` Create an InternalLink based on the given XML attribute value.
`InternalLink(String pvKey, String idRef)` Create an InternalLink to the given PageViewport and target ID

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`String` `getIDRef()` Returns the target ID.
`String` `getPVKey()` Returns the key of the targeted PageViewport.
`static String` `makeXMLAttribute(String pvKey, String idRef)` Returns the XML attribute value for the given PV key and ID ref.
`static String[]` `parseXMLAttribute(String attrValue)` Parses XML attribute value from the area tree into PageViewport key + IDRef strings.
`void` `setIDRef(String idRef)` Sets the target ID.
`void` `setPVKey(String pvKey)` Sets the key of the targeted PageViewport.
`String` `toString()` Return the human-friendly string for debugging.
`String` `xmlAttribute()` Returns the attribute value for this object as used in the area tree XML.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### InternalLink

    public InternalLink(String pvKey,
                        String idRef)

Create an InternalLink to the given PageViewport and target ID

Parameters:
  `pvKey` - the PageViewport key
  `idRef` - the target ID

#### InternalLink

    public InternalLink(String attrValue)

Create an InternalLink based on the given XML attribute value. This is typically called when data are read from an XML area tree.

Parameters:
  `attrValue` - attribute value to be parsed by InternalLink.parseXMLAttribute

### Method Detail

#### setPVKey

    public void setPVKey(String pvKey)

Sets the key of the targeted PageViewport.

Parameters:
  `pvKey` - the PageViewport key

#### getPVKey

    public String getPVKey()

Returns the key of the targeted PageViewport.

Returns:
  the PageViewport key

#### setIDRef

    public void setIDRef(String idRef)

Sets the target ID.

Parameters:
  `idRef` - the target ID

#### getIDRef

    public String getIDRef()

Returns the target ID.

Returns:
  the target ID

#### xmlAttribute

    public String xmlAttribute()

Returns the attribute value for this object as used in the area tree XML.

Returns:
  a string of the type "(thisPVKey,thisIDRef)"

#### makeXMLAttribute

    public static String makeXMLAttribute(String pvKey,
                                          String idRef)

Returns the XML attribute value for the given PV key and ID ref. This value is used in the area tree XML.

Parameters:
  `pvKey` - the PageViewport key of the link target
  `idRef` - the ID of the link target
Returns:
  a string of the type "(thisPVKey,thisIDRef)"

#### parseXMLAttribute

    public static String[] parseXMLAttribute(String attrValue)

Parses XML attribute value from the area tree into PageViewport key + IDRef strings. If the attribute value is formatted like "(s1,s2)", then s1 and s2 are considered to be the PV key and the IDRef, respectively. Otherwise, the entire string is the PV key and the IDRef is null.

Parameters:
  `attrValue` - the atribute value (PV key and possibly IDRef)
Returns:
  a 2-String array containing the PV key and the IDRef. Both may be null.

#### toString

    public String toString()

Return the human-friendly string for debugging.

Overrides:
  `toString` in class `Object`